// Level structs & functions
// Patched for just one fixed level

#define ENEMS_DATA		malotes
#define MAX_REFILLS		8

typedef struct {
	unsigned char xy;
	unsigned char act;
} HOTSPOT;

HOTSPOT hotspots [36];
unsigned char hotspot_x, hotspot_y;

typedef struct {
	unsigned char frame;
	unsigned char count;
	unsigned char facing;
	unsigned char *current_frame, *next_frame, *base_frame;
	int x;
	int y;
	int vx;
	int vy;
} ANIMADO;

ANIMADO en_an [3];

unsigned char orig_tile;
extern unsigned char map_buffer [0];
extern unsigned int level_pointer [0];

#asm
	._level_pointer	
		defw	0
	._map_buffer
		defs 	150, 0
#endasm

// 0 nothing
// 1 kills
// 2 platform
// 3 solid
// 4 <-
// 5 ->

unsigned char tile_behaviour [] = {
	0, 0, 3, 0, 3, 0, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
	3, 3, 3, 3, 3, 0, 0, 0, 0, 3, 3, 3, 3, 3, 1, 3,
	3, 0, 3, 3, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 3,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
};

// Screen names

extern unsigned char screen_names [];

#asm
	._screen_names
		defm " ZARAGOZA#S NIGHT  "
		defm "RITMO EN EL ESPACIO"
		defm "      TERRAZA      "
		defm "      TERRAZA      "
		defm "     GUITARRA      "
		defm "      TERRAZA      "
		
		defm "   SIGUE BAJANDO   "
		defm "SALA EXPOSICION P4 "
		defm "SALA EXPOSICION P4 "
		defm "SALA EXPOSICION P4 "
		defm "SALA EXPOSICION P4 "
		defm "SALA EXPOSICION P4 "
		
		defm "   SIGUE BAJANDO   "
		defm "   DRAMA Y QUEMA   "
		defm "SALA EXPOSICION P3 "
		defm "SALA EXPOSICION P3 "
		defm "SALA EXPOSICION P3 "
		defm "SALA EXPOSICION P3 "
		
		defm "   SIGUE BAJANDO   "
		defm " MACHADO RETRATADO "
		defm "   P.SERRANO P2    "
		defm "   P.SERRANO P2    "
		defm "   P.SERRANO P2    "
		defm "   P.SERRANO P2    "
		
		defm " PSO. MARIAGUSTIN  "
		defm " ENTRADA AL MUSEO  "
		defm "     PLANTA 0      "
		defm "     PLANTA 0      "
		defm "     PLANTA 0      "
		defm "     PLANTA 0      "
		
		defm "    EL FAJADITO    "
		defm "      ALMACEN      "
		defm "      ALMACEN      "
		defm "      ALMACEN      "
		defm "      ALMACEN      "
		defm "      ALMACEN      "
#endasm

void __FASTCALL__ draw_coloured_tile (unsigned char x, unsigned char y, unsigned char t) {
	unsigned int st_index;
	unsigned char *pointer;
	if (t > 47) t = 0;
	st_index = 64 + (t << 2);
	pointer = (unsigned char *) &tileset [2048 + st_index];
	sp_PrintAtInv (y    , x    , pointer [0], st_index);
	sp_PrintAtInv (y    , x + 1, pointer [1], st_index + 1);
	sp_PrintAtInv (y + 1, x    , pointer [2], st_index + 2);
	sp_PrintAtInv (y + 1, x + 1, pointer [3], st_index + 3);
}

void wait_fire () {
	unsigned char i;
	do {
		i = (joyfunc) (&keys);
	} while ((i & sp_UP) != 0);	
	
	do {
		i = (joyfunc) (&keys);
	} while ((i & sp_UP) == 0);
}

void load_level () {
	unsigned char x, y;
	unsigned char np, xp, yp, tile;
	unsigned int i;
	unsigned char *pointer;
	
	// No level jugging, just prepare the map
	// Objects:
	// 41->51, 42->52, 43->53, 44->54, 45->55
	// Keys:
	// 46->56
	// Gates:
	// 47->57
	// Aqu hay que deshacer esto:
	
	for (i = 0; i < 5400; i ++) {
		if (mapa [i] > 47)
			mapa [i] -= 10;	
	}
	// Init objects	
	for (i = 0; i < 5; i ++)
		objects [i] = 0;
		
	// Place extra life
	for (i = 0; i < 36; i ++) {
		hotspots [i].act = 0;
		hotspots [i].xy = 0;
	}
	for (i = 0; i < 8; i ++) {
		do {
			xp = rand () % 6;
			yp = rand () % 6;
			np = xp + 6 * yp;
		} while (hotspots [np].act);

		hotspots [np].act = 1;
		
		do {
			x = rand () % 15;
			y = rand () % 10;
			tile = mapa [(yp * 10 + y) * 90 + xp * 15 + x];
		} while (tile_behaviour [tile] != 0);
		
		hotspots [np].xy = (x << 4) + y;
	}
}

void render_screen () {
	unsigned char *map_pointer; 
	unsigned char y = 0, x = 0;
	unsigned char i;
	unsigned char t;
	unsigned char n_pant;
	unsigned char *screen_name;
	
	n_pant = y_pant * 6 + x_pant;	
	map_pointer = (unsigned char *) (mapa + y_pant * 10 * 90 + x_pant * 15);
	
	for (i = 0; i < 150; i ++) {
		t = *map_pointer;
		map_buffer [i] = t;
		
		draw_coloured_tile (VIEWPORT_X + x, VIEWPORT_Y + y, t);
		
		map_pointer ++;
		x += 2;
		if (x == 30) {
			y += 2;
			x = 0;
			map_pointer += 75;	
		}
	}
	
	// Create enemies:
	
	enoffs = n_pant * 3;
	
	for (i = 0; i < 3; i ++) {
		en_an [i].frame = 0;
		en_an [i].count = 0;
		
		// If defined, frame = sprite_9_a + (2 frames) * (type - 1).
		if (malotes [enoffs + i].t < 5) {
			en_an [i].base_frame = sprite_9_a + 288 * (malotes [enoffs + i].t - 1);
			en_an [i].next_frame = en_an [i].base_frame;
		} else {
			en_an [i].base_frame = sprite_9_a + 1152 + 576 * (malotes [enoffs + i].t - 5);
			en_an [i].next_frame = en_an [i].base_frame;
		}
		
		en_an [i].frame = 0;
	}
	
	// Create hotspots
	
	hotspot_x = hotspot_y = 240;
	if (hotspots [n_pant].act == 1) {
		x = (hotspots [n_pant].xy >> 4);
		y = (hotspots [n_pant].xy & 15);
		hotspot_x = x << 4;
		hotspot_y = y << 4;		
		orig_tile = mapa [(y_pant * 10 + y) * 90 + x_pant * 15 + x];
		x = VIEWPORT_X + x + x;
		y = VIEWPORT_Y + y + y;
		sp_PrintAtInv (y    , x    , 6, 4);
		sp_PrintAtInv (y    , x + 1, 70, 5);
		sp_PrintAtInv (y + 1, x    , 70, 6);
		sp_PrintAtInv (y + 1, x + 1, 70, 7);
	}
	
	// Screen name
	
	screen_name = screen_names + 19 * n_pant;
	for (i = 0; i < 19; i ++) {
		sp_PrintAtInv (23, 8 + i, 71, (*screen_name) - 32);
		screen_name ++;
	}	
}

// Ergo.
